%% Two Link Robot

close all; clear all; clc;

L(1)=Link([0 0 1 0]);
L(2)=Link([0 0 1 0]);

two_link=SerialLink(L,'name','two_link')

two_link.gravity;     % returns the gravity vector
two_link.base;
two_link.tool;
two_link.n;              % returns the number of joints
two_link.links;          % returns the details of the links 
qi=[0 0];
T1=two_link.fkine(qi)
two_link.plot(qi)
q2=[pi/4 -pi/4];
T2=two_link.fkine(q2)
figure
two_link.plot(q2)

%% This section is to creat a clone of the robot
bob=SerialLink(two_link, 'name', 'bob') % this is to creat a clone object of the same robot

bob.base=[1 0 0 1; 0 1 0 2; 0 0 1 0;0 0 0 1];
bob.fkine([pi/4 -pi/4])
hold on
bob.plot([pi/4 -pi/4])
axis([-5 5 -5 5 -5 5])
grid

%% Inverse kinematics --- underactuated
 qs=two_link.ikine(T2,qi, 'mask', [1 1 0 0 0 0]); % qi is initial value for the search problem. number of ones of the mask should be >= number of active links
 figure
 LL={'g', 'LineWidth', 2};
 two_link.plot(qs,'workspace',[-5 5 -5 5 -5 5], 'trail', LL,'tilesize',0.01)

