%% Puma560
close all; clear all; clc;

mdl_puma560;
p560
p560.plot(qz)
T1=p560.fkine(qz)
figure
p560.plot(qr)
figure
p560.plot(qs)
figure
p560.plot(qn)

p560.tool=transl(0,0,0.2); % this is to change the position of the Tool Center Point (TCP) ... note the difference T1 & T2
T2=p560.fkine(qz)

%% inverse kinematics --- close form solution (different solutions)
T=p560.fkine(qn);
qn
q_inv=p560.ikine6s(T)               % this is to find the closed form solution for the inverse kinematics problem
p560.plot(qn)
figure
p560.plot(q_inv)

q_inv_ru=p560.ikine6s(T,'ru')   %This is to force the inverse kinematics to find the right handed upper solution
p560.plot(q_inv_ru)

q_inv_ld=p560.ikine6s(T,'ld')   %This is to force the inverse kinematics to find the right handed upper solution
p560.plot(q_inv_ld)

%% Inverse kinematics --- Numerical solution
T=p560.fkine(qn);
qn
qi=p560.ikine(T)            % this will result in an elbow down config

figure
TT=p560.fkine(qi)
p560.plot(qi)

%% Trajectory in joint space
figure
t=0:0.1:1;
qq=jtraj(qs,qr,t)
ll={'g','linewidth',2}
p560.plot(qq, 'trail', ll)

%% trajectory in cartesian space

tn=0:0.2:1;
T1=transl(0.4,-0.5,0)* trotx(pi);
T2=transl(0.4,0.5,0)* trotx(pi/2);
TC=ctraj(T1,T2,length(tn));
qc=p560.ikine6s(TC,qz)
figure
p560.plot(qc, 'trail', ll)



